# Exercice de Chiffrement

## Exercice 1 Chiffrement XOR

- voici la table des codes ascii : 

![ascii](https://upload.wikimedia.org/wikipedia/commons/thumb/1/1b/ASCII-Table-wide.svg/1200px-ASCII-Table-wide.svg.png){.w80}

- voici la table Hexadécimal

![Hexa](http://pedagogie.ac-limoges.fr/sti_si/accueil/FichesConnaissances/Sequence2SSi/res/tableau_hexa.png){.w40}



### sujet :

- j'ai chiffré en XOR un message confidentiel qui désigne le champion du déchiffrement ...
- le message chiffré avec la clé Hex "0A0C0F" est "Gcf"

- Quelle est la longueur (en bits) de la clé ?
- Quel est le message déchiffré en texte ?



### corrigé :

```
1) La clé comporte 6 codes hexadécimaux codés sur 4 bits ; sa longueur est donc 24 bits.

2) conversion ASCII -> binaire du message chiffré
G -> 47 -> 0100 0111
c -> 63 -> 0110 0011
f -> 66 -> 0110 0110

3) conversion Hex -> binaire de la clé
0 -> 0b0 -> 0000
A -> 0b1010 -> 1010
0 -> 0b0 -> 0000
C -> 0b1100 -> 1100
0 -> 0b0 -> 0000
F -> 0b1111 -> 1111

4) XOR
        message (bin) = 0100 0111 0110 0011 0110 0110
            clé (bin) = 0000 1010 0000 1100 0000 1111
message XOR clé (bin) = 0100 1101 0110 1111 0110 1001

5) Conversion binaire ASCII du message 
0100 1101 -> 4D -> M
0110 1111 -> 6F -> o
0110 1001 -> 69 -> i

Le message déchiffré est donc : "Moi"
```


## script python


### chiffrement xor détaillé

```

def humanBinary(bin,nb) :
    # ajoute un espace tous les 4 caractères de la chaine bin  
    # après avoir enlevé les 2 premiers caractères de gauche (0b)
    # et formaté la chaine avec des 0 non significatifs pour obtenir nb caractères
    res = ""
    #strBin = str(bin)[2:]
    binFormated = bin.zfill(nb)

    for i, c in enumerate(binFormated):
        if i % 4 == 0 and i > 0:
            res += " "
        res += c

    return res



print()
message = input("Quel est le message (en chaine de caractères) ? ")

print('message est : {}'.format(message))
messageBits = []

for messageChar in message :
    ascii_messageChar = messageChar.encode('ascii')
    hex_messageChar = ascii_messageChar.hex()
    binary_messageChar = bin(int(hex_messageChar, 16))
    hBinary_messageChar = humanBinary(binary_messageChar[2:],8)

    for bit in hBinary_messageChar :
        if bit != ' ' :
            messageBits.append(bit)

    print('{} -> {} -> {} -> {} -> {}'.format(messageChar,ascii_messageChar,hex_messageChar,binary_messageChar,hBinary_messageChar))

print(messageBits)
print(len(messageBits))

print()
lenMessageBits = len(messageBits)
print('le message a une longueur de {} bits'.format(lenMessageBits))

print()
hex_key = input("Quel est la clé de chiffrement (en hexadécimal) ? ")


print('hex_key est : {}'.format(hex_key))
keyBits = []

for hex_keyNumber in hex_key :
    binary_keyNumber = bin(int(hex_keyNumber, 16))
    hBinary_keyNumber = humanBinary(binary_keyNumber[2:],4)  

    for bit in hBinary_keyNumber :
        if bit != ' ' :
            keyBits.append(bit)

    print('{} -> {} -> {}'.format(hex_keyNumber,binary_keyNumber, hBinary_keyNumber))

print()
lenKeyBits = len(keyBits)
print('la clé est une clé de {} bits'.format(lenKeyBits))

print()

print('XOR bit à bit :')

xorBits = []
rkeyBits = []
for i in range(0,lenMessageBits) :
    # si la clé est plus petite que le message, il faut le reboucler :
    j = i % int(lenKeyBits)
    xorBit = int(messageBits[i]) ^ int(keyBits[j])
    print('{}-{} : {} xor {} = {}'.format(i,j,messageBits[i], keyBits[j], xorBit))
    xorBits.append(str(xorBit))
    rkeyBits.append(str(keyBits[j]))


print()

print('        message (bin) = {}'.format(humanBinary("".join(messageBits),lenMessageBits)))
print('            clé (bin) = {}'.format(humanBinary("".join(rkeyBits),lenMessageBits)))
print('message XOR clé (bin) = {}'.format(humanBinary("".join(xorBits),lenMessageBits)))

binary_cypher = "".join(xorBits)
hex_cypher = hex(int(binary_cypher,2))

cypherChars = []
for i in range (2, len(hex_cypher), 2) :
    hexaString = str(hex_cypher[i]) + str(hex_cypher[i+1])
    try :
        cypherChar = chr(int(hexaString,16))
        cypherChars.append(cypherChar)
    except :
        cypherChars.append('?')
    # print('le code ascii de {} = {}'.format(hexaString, cypherChar)) 
cypherText = ''.join(cypherChars)


print()
print('soit en hexadécimal : {} '.format(hex_cypher[2:]))
print('soit en texte : {} '.format(cypherText))
```

- utilisation :

```
Quel est le message (en chaine de caractères) ? salut le monde
Quel est la clé de chiffrement (en hexadécimal) ? 010203

la clé est une clé de 24 bits

        message (bin) = 0111 0011 0110 0001 0110 1100 0111 0101 0111 0100 0010 0000 0110 1100 0110 0101 0010 0000 0110 1101 0110 1111 0110 1110 0110 0100 0110 0101
            clé (bin) = 0000 0001 0000 0010 0000 0011 0000 0001 0000 0010 0000 0011 0000 0001 0000 0010 0000 0011 0000 0001 0000 0010 0000 0011 0000 0001 0000 0010
message XOR clé (bin) = 0111 0010 0110 0011 0110 1111 0111 0100 0111 0110 0010 0011 0110 1101 0110 0111 0010 0011 0110 1100 0110 1101 0110 1101 0110 0101 0110 0111

soit en hexadécimal : 72636f7476236d67236c6d6d6567 
soit en texte : rcotv#mg#lmmeg
```


### chiffrement xor compact

```
message = input("Quel est le message (en chaine de caractères) ? ")
hex_key = input("Quel est la clé de chiffrement (en hexadécimal) ? ")

print()

binary_message = ''.join([bin(ord(char))[2:].zfill(8) for char in message])
print('        message (bin) = {}'.format(binary_message))

binary_key = '{:0>{width}}'.format(bin(int(hex_key, 16))[2:], width=len(hex_key)*4)
bk = binary_key
while (len(binary_key) < len(binary_message)) :
    # agmentation de la taille de la clé par répétition
    binary_key += bk

# clé à la taille exacte du message
binary_key=binary_key[:len(binary_message)]
print('            clé (bin) = {}'.format(binary_key))

# XOR
binary_cypher = int(binary_message,2) ^ int(binary_key,2)
print('message XOR clé (bin) = {}'.format(bin(binary_cypher)[2:]))

hex_cypher = hex(binary_cypher)

print()
print('soit, en hexadécimal : {} '.format(hex_cypher))

byte_cypher = bytes.fromhex(hex_cypher[2:])
ascii_cypher = byte_cypher.decode("ASCII")
print('soit,       en texte : {} '.format(ascii_cypher))
```